#include <tchar.h>
#include <Windows.h>
#include <Shlwapi.h>
#include <memory>
#include "constants.hpp"
#include "MainWindow.hpp"
#include "resource.h"
#include "StringTable.hpp"
#include "ScopeExitMutex.hpp"
#include "ScopeExitGdiObject.hpp"

TCHAR* INI_FILE_PATH = nullptr;
HBRUSH BACKGROUND_BRUSH = nullptr;

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);
	UNREFERENCED_PARAMETER(nCmdShow);

	// 2dN͂Ȃ(zbgL[ĝł₱Ȃ)
	HANDLE mutexHandle = CreateMutex(NULL, TRUE, _T("Key sequencer"));
	if (GetLastError() == ERROR_ALREADY_EXISTS)
	{
		CloseHandle(mutexHandle);
		return 1;
	}
	ScopeExitMutex scopeExitMutex(mutexHandle);


	// \[X當e[u𐶐
	StringTable stringTable(hInstance);


	// ݒt@CpX𐶐
	std::unique_ptr<TCHAR[]> scopeExitIniFilePath(new TCHAR[MAX_PATH]);
	INI_FILE_PATH = scopeExitIniFilePath.get();

	// st@C̃tpX擾
	if (GetModuleFileName(NULL, INI_FILE_PATH, MAX_PATH) == 0)
	{
		MessageBox(nullptr, StringTable::get(IDS_ERROR_APPLICATION_INITIALIZE), StringTable::get(IDS_ERRORDIALOG_CAPTION), ERROR_DIALOG_TYPE);
		return 1;
	}

	// tH_ɓOŊgq.iniɕς
	if (!PathRenameExtension(INI_FILE_PATH, _T(".ini")))
	{
		MessageBox(nullptr, StringTable::get(IDS_ERROR_APPLICATION_INITIALIZE), StringTable::get(IDS_ERRORDIALOG_CAPTION), ERROR_DIALOG_TYPE);
		return 1;
	}


	// wip̃uV
	BACKGROUND_BRUSH = CreateSolidBrush(BACKGROUND_COLOR);
	ScopeExitGdiObject scopeExitGdiObject(BACKGROUND_BRUSH);


	// CEBhE𐶐ďJn
	MainWindow mainWindow(hInstance);
	if (mainWindow.initialize())
		mainWindow.run();
	else
		MessageBox(nullptr, StringTable::get(IDS_ERROR_APPLICATION_INITIALIZE), StringTable::get(IDS_ERRORDIALOG_CAPTION), ERROR_DIALOG_TYPE);


	return 0;
}
